package com.xy.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.xy.dto.DeviceStatusDto;
import com.xy.entity.DeviceStatus;
import com.xy.mapper.DeviceStatusMapper;
import com.xy.service.DeviceStatusService;
import com.xy.utils.R;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.stereotype.Service;

import static com.xy.utils.Beans.copy;

/**
 * <p>
 * 设备-状态 服务实现类
 * </p>
 *
 * @author lijin
 * @since 2022-12-23
 */
@Service
@Api(tags = "设备-状态")
public class DeviceStatusServiceImpl extends ServiceImpl<DeviceStatusMapper, DeviceStatus> implements DeviceStatusService {

    @Override
    @ApiOperation("上报信息")
    public R up(DeviceStatusDto.Up up) {
        DeviceStatus deviceStatusInfo = getById(up.getDeviceId());
        if (deviceStatusInfo == null) {
            return R.ok();
        }
        DeviceStatus deviceStatus = copy(DeviceStatus.class, up);
        updateById(deviceStatus);
        return R.ok();
    }
}
