package com.xy.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.xy.dto.DeviceSysinfoDto;
import com.xy.entity.DeviceSysinfo;
import com.xy.mapper.DeviceSysinfoMapper;
import com.xy.service.DeviceSysinfoService;
import com.xy.utils.Emptys;
import com.xy.utils.MybatisPlusQuery;
import com.xy.utils.R;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.stereotype.Service;

import java.util.List;

import static com.xy.utils.Beans.copy;

/**
 * <p>
 * 设备-系统信息 服务实现类
 * </p>
 *
 * @author lijin
 * @since 2022-12-23
 */
@Service
@Api(tags = "设备-系统信息")
public class DeviceSysinfoServiceImpl extends ServiceImpl<DeviceSysinfoMapper, DeviceSysinfo> implements DeviceSysinfoService {

    @Override
    @ApiOperation("查询对象")
    public R<DeviceSysinfoDto.Vo> get(DeviceSysinfoDto.Select select) {
        LambdaQueryWrapper<DeviceSysinfo> lambdaQueryWrapper = new MybatisPlusQuery().eqWrapper(select, DeviceSysinfo.class)
                .ge(DeviceSysinfo::getCreateTime, select.getBeginCreateTime())
                .le(DeviceSysinfo::getCreateTime, select.getEndCreateTime())
                .build();
        List<DeviceSysinfo> list = list(lambdaQueryWrapper);
        if (!Emptys.check(list)) {
            return R.ok(new DeviceSysinfoDto.Vo());
        }
        return R.ok(copy(DeviceSysinfoDto.Vo.class, list.get(0)));
    }

    @Override
    @ApiOperation("上报信息")
    public R up(DeviceSysinfoDto.Up up) {
        DeviceSysinfo deviceSysinfo = getById(up.getDeviceId());
        if (deviceSysinfo == null) {
            return R.ok();
        }
        updateById(copy(DeviceSysinfo.class, up));
        return R.ok();
    }
}
