package com.xy.dto.son;

import com.xy.dto.pater.PaterDto;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import java.math.BigDecimal;
import java.util.List;

@Data
@ApiModel("摄像头")
@Accessors(chain = true)
public class CameraDto extends PaterDto {

    @ApiModelProperty("摄像头编号")
    private String cameraId;

    @ApiModelProperty("视频帧率")
    private BigDecimal videoRate;

    @ApiModelProperty("视频码流")
    private BigDecimal videoStream;

    @ApiModelProperty("清空视频")
    private Boolean clearVideo;

    @ApiModelProperty("清空图片")
    private Boolean clearTake;

    @ApiModelProperty("清理指定日期视频")
    private String clearVideoByTime;

    @ApiModelProperty("清理指定日期图片")
    private String clearTakeByTime;

    @ApiModelProperty("录制指定时长的视频 单位：秒")
    private Integer videoByTime;

    @ApiModelProperty("拍摄指定次数的照片 单位：次")
    private Integer takeByNum;

    @ApiModelProperty("开关 true=开 false=关")
    private Boolean onff;

    @ApiModelProperty("补报视频/图片")
    private List<Repeat> repeat;

    @Data
    public static class Repeat {
        @ApiModelProperty("订单编号")
        private String orderId;

        @ApiModelProperty("业务类型")
        private String type;
    }
}
