package com.xy.utils;

import com.xy.dto.son.*;
import com.xy.utils.enums.MqttEnum;
import lombok.SneakyThrows;

import java.lang.reflect.Method;

/**
 * 指令构造工具类
 */
public class CommandUtils {

    @SneakyThrows
    private static <T> T news(Class<T> tClass, String type) {
        T t = tClass.newInstance();
        Method setType = tClass.getMethod("setType", String.class);
        setType.invoke(t, type);
        return t;
    }

    /**
     * 摄像头
     *
     * @return
     */
    public static CameraDto camera() {
        return news(CameraDto.class, MqttEnum.COMMAND_CAMERAS.getKey());
    }

    /**
     * 电池
     *
     * @return
     */
    public static CellDto cell() {
        return news(CellDto.class, MqttEnum.COMMAND_CELL.getKey());
    }

    /**
     * 自检
     *
     * @return
     */
    public static CheckDto check() {
        return news(CheckDto.class, MqttEnum.COMMAND_CHECK.getKey());
    }

    /**
     * 灯
     *
     * @return
     */
    public static LampDto lamp() {
        return news(LampDto.class, MqttEnum.COMMAND_LAMP.getKey());
    }

    /**
     * 锁机
     *
     * @return
     */
    public static LockDeviceDto LockDevice() {
        return news(LockDeviceDto.class, MqttEnum.COMMAND_LOCK_DEVICE.getKey());
    }

    /**
     * 门锁
     *
     * @return
     */
    public static LockDto lock() {
        return news(LockDto.class, MqttEnum.COMMAND_LOCK.getKey());
    }

    /**
     * 日志
     *
     * @return
     */
    public static LogDto log() {
        return news(LogDto.class, MqttEnum.COMMAND_LOG.getKey());
    }

    /**
     * 温度
     *
     * @return
     */
    public static TemperatureDto temperature() {
        return news(TemperatureDto.class, MqttEnum.COMMAND_TEMPERATURE.getKey());
    }
}
